//+------------------------------------------------------------------+
//|                                                   STLM_hist.mq4  |
//|                                       Ramdass - Conversion only  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkSlateGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "stlm Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;

double upH[];
double dnH[];
double stlm[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{ 
   IndicatorBuffers(4);
   SetIndexBuffer(0,upH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,stlm);
   SetIndexBuffer(3,trend); 
   IndicatorShortName("Stlm");
return(0);
}

int deinit() 
{  
   deleteArrows(); 
   
return(0); 
}

//+------------------------------------------------------------------+
//| STLM                                                             |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i=limit; i >= 0; i--)
   {
       double value1 =
       0.0982862174*Close[i+0]
       +0.0975682269*Close[i+1]
       +0.0961401078*Close[i+2]
       +0.0940230544*Close[i+3]
       +0.0912437090*Close[i+4]
       +0.0878391006*Close[i+5]
       +0.0838544303*Close[i+6]
       +0.0793406350*Close[i+7]
       +0.0743569346*Close[i+8]
       +0.0689666682*Close[i+9]
       +0.0632381578*Close[i+10]
       +0.0572428925*Close[i+11]
       +0.0510534242*Close[i+12]
       +0.0447468229*Close[i+13]
       +0.0383959950*Close[i+14]
       +0.0320735368*Close[i+15]
       +0.0258537721*Close[i+16]
       +0.0198005183*Close[i+17]
       +0.0139807863*Close[i+18]
       +0.0084512448*Close[i+19]
       +0.0032639979*Close[i+20]
       -0.0015350359*Close[i+21]
       -0.0059060082*Close[i+22]
       -0.0098190256*Close[i+23]
       -0.0132507215*Close[i+24]
       -0.0161875265*Close[i+25]
       -0.0186164872*Close[i+26]
       -0.0205446727*Close[i+27]
       -0.0219739146*Close[i+28]
       -0.0229204861*Close[i+29]
       -0.0234080863*Close[i+30]
       -0.0234566315*Close[i+31]
       -0.0231017777*Close[i+32]
       -0.0223796900*Close[i+33]
       -0.0213300463*Close[i+34]
       -0.0199924534*Close[i+35]
       -0.0184126992*Close[i+36]
       -0.0166377699*Close[i+37]
       -0.0147139428*Close[i+38]
       -0.0126796776*Close[i+39]
       -0.0105938331*Close[i+40]
       -0.0084736770*Close[i+41]
       -0.0063841850*Close[i+42]
       -0.0043466731*Close[i+43]
       -0.0023956944*Close[i+44]
       -0.0005535180*Close[i+45]
       +0.0011421469*Close[i+46]
       +0.0026845693*Close[i+47]
       +0.0040471369*Close[i+48]
       +0.0052380201*Close[i+49]
       +0.0062194591*Close[i+50]
       +0.0070340085*Close[i+51]
       +0.0076266453*Close[i+52]
       +0.0080376628*Close[i+53]
       +0.0083037666*Close[i+54]
       +0.0083694798*Close[i+55]
       +0.0082901022*Close[i+56]
       +0.0080741359*Close[i+57]
       +0.0077543820*Close[i+58]
       +0.0073260526*Close[i+59]
       +0.0068163569*Close[i+60]
       +0.0062325477*Close[i+61]
       +0.0056078229*Close[i+62]
       +0.0049516078*Close[i+63]
       +0.0161380976*Close[i+64];
       //----
       double value2 =
       -0.0074151919*Close[i+0]
       -0.0060698985*Close[i+1]
       -0.0044979052*Close[i+2]
       -0.0027054278*Close[i+3]
       -0.0007031702*Close[i+4]
       +0.0014951741*Close[i+5]
       +0.0038713513*Close[i+6]
       +0.0064043271*Close[i+7]
       +0.0090702334*Close[i+8]
       +0.0118431116*Close[i+9]
       +0.0146922652*Close[i+10]
       +0.0175884606*Close[i+11]
       +0.0204976517*Close[i+12]
       +0.0233865835*Close[i+13]
       +0.0262218588*Close[i+14]
       +0.0289681736*Close[i+15]
       +0.0315922931*Close[i+16]
       +0.0340614696*Close[i+17]
       +0.0363444061*Close[i+18]
       +0.0384120882*Close[i+19]
       +0.0402373884*Close[i+20]
       +0.0417969735*Close[i+21]
       +0.0430701377*Close[i+22]
       +0.0440399188*Close[i+23]
       +0.0446941124*Close[i+24]
       +0.0450230100*Close[i+25]
       +0.0450230100*Close[i+26]
       +0.0446941124*Close[i+27]
       +0.0440399188*Close[i+28]
       +0.0430701377*Close[i+29]
       +0.0417969735*Close[i+30]
       +0.0402373884*Close[i+31]
       +0.0384120882*Close[i+32]
       +0.0363444061*Close[i+33]
       +0.0340614696*Close[i+34]
       +0.0315922931*Close[i+35]
       +0.0289681736*Close[i+36]
       +0.0262218588*Close[i+37]
       +0.0233865835*Close[i+38]
       +0.0204976517*Close[i+39]
       +0.0175884606*Close[i+40]
       +0.0146922652*Close[i+41]
       +0.0118431116*Close[i+42]
       +0.0090702334*Close[i+43]
       +0.0064043271*Close[i+44]
       +0.0038713513*Close[i+45]
       +0.0014951741*Close[i+46]
       -0.0007031702*Close[i+47]
       -0.0027054278*Close[i+48]
       -0.0044979052*Close[i+49]
       -0.0060698985*Close[i+50]
       -0.0074151919*Close[i+51]
       -0.0085278517*Close[i+52]
       -0.0094111161*Close[i+53]
       -0.0100658241*Close[i+54]
       -0.0104994302*Close[i+55]
       -0.0107227904*Close[i+56]
       -0.0107450280*Close[i+57]
       -0.0105824763*Close[i+58]
       -0.0102517019*Close[i+59]
       -0.0097708805*Close[i+60]
       -0.0091581551*Close[i+61]
       -0.0084345004*Close[i+62]
       -0.0076214397*Close[i+63]
       -0.0067401718*Close[i+64]
       -0.0058083144*Close[i+65]
       -0.0048528295*Close[i+66]
       -0.0038816271*Close[i+67]
       -0.0029244713*Close[i+68]
       -0.0019911267*Close[i+69]
       -0.0010974211*Close[i+70]
       -0.0002535559*Close[i+71]
       +0.0005231953*Close[i+72]
       +0.0012297491*Close[i+73]
       +0.0018539149*Close[i+74]
       +0.0023994354*Close[i+75]
       +0.0028490136*Close[i+76]
       +0.0032221429*Close[i+77]
       +0.0034936183*Close[i+78]
       +0.0036818974*Close[i+79]
       +0.0038037944*Close[i+80]
       +0.0038338964*Close[i+81]
       +0.0037975350*Close[i+82]
       +0.0036986051*Close[i+83]
       +0.0035521320*Close[i+84]
       +0.0033559226*Close[i+85]
       +0.0031224409*Close[i+86]
       +0.0028550092*Close[i+87]
       +0.0025688349*Close[i+88]
       +0.0022682355*Close[i+89]
       +0.0073925495*Close[i+90];
       
       stlm[i]  = value1 - value2;
       
       //
       //
       //
       //
       //
       
       upH[i]   = EMPTY_VALUE;
       dnH[i]   = EMPTY_VALUE;
       trend[i] = trend[i+1];
       if(stlm[i]>stlm[i+1]) trend[i] = 1;
       if(stlm[i]<stlm[i+1]) trend[i] =-1; 
       if(trend[i] == 1)     upH[i] = stlm[i];
       if(trend[i] ==-1)     dnH[i] = stlm[i];
       
       //
       //
       //
       //
       //
       
       if (ShowArrows)
       {
          deleteArrow(Time[i]);
          if (trend[i] != trend[i+1])
          {
            if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
          }
       }
               
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int whichBar = 0;
      else      whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }   
return(0);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" STLM_hist changed trend to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," STLM_hist " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," STLM_hist "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}



